<template lang="html">
  <div class="categories-editor">
    <h4 v-if="selected.length > 0">Categorias selecionadas (máximo de {{this.max}})</h4>
    <ul class="list-values" v-if="selected">
      <li v-for="(item, index) in selected">
        {{returnValue(item, keylabel)}}
        <button type="button"
          class="button is-link is-small is-pulled-right"
          :disabled="disabledRemoveBtns[index] || selected.length == 1"
          @click="removeItem(item)">
            remover
          </button>
        <loadermini class=" is-pulled-right"
          :listenFor="`DELETE:Category:CatEditor:${item.id}`"
          @loadingstart="disabledRemoveBtns[index] = true"
          @loadingend="disabledRemoveBtns[index] = false"
          leftText="Aguarde..." />
      </li>
    </ul>
    <p class="control" v-for="(item, index) in listItems" :class="{ 'disabled': disable }">
      <label>
        <input type="checkbox"
          :name="name"
          :value="item"
          @change="addCat(item)"
          :disabled="disable || disabledCheck[index]"
          v-model="selected">
        {{item.number}} - {{returnValue(item, keylabel)}}
        <loadermini
          :listenFor="`POST:Category:CatEditor:${item.id}`"
          @loadingstart="disabledCheck[index] = true"
          @loadingend="disabledCheck[index] = false" />
        <!-- <span class="help-block" v-if="item[keyhelp]">{{item[keyhelp]}}</span> -->
      </label>
    </p>
  </div>
</template>

<script>
import { addOds, deleteOds } from '../api/ods.service'
import loadermini from './loader-mini-component.vue'

export default {
  name: "CategoriesEditor",
  components: {loadermini},
  props: {
    items: {
      type: Array,
      required: true
    },
    selectedItems: {
      required: true
    },
    max: {
      type: Number
    },
    keylabel: {
      type: String
    },
    keyhelp: {
      type: String
    },
    keyvalue: {
      type: String
    },
    name: {
      type: String,
      required: true
    },
    solutionId: {
      required: true
    }
  },
  data() {
    return {
      listItems: [],
      selected: [],
      disabledRemoveBtns: {},
      disabledCheck: {}
    }
  },
  methods: {
    removeItem: function(item) {
      deleteOds(this.solutionId, item.id)
        .then(success => {
          let index = this.selected.indexOf(item);
          this.selected.splice(index, 1);
          this.listItems.push(item);
        })
    },
    returnValue(item, key) {
      if (item[key]) {
        return item[key];
      } else {
        return item;
      }
    },
    addCat(item) {
      if (item) {
        addOds(this.solutionId, item.id)
          .then(
            success => {
              this.removeSelecteds();
            }
          )
      }
    },
    removeSelecteds() {
      for (let i = 0; i < this.selected.length; i++) {
        for (let j = 0; j < this.listItems.length; j++) {
          if (this.selected[i].id == this.listItems[j].id) {
            let index = this.listItems.indexOf(this.listItems[j]);
            this.listItems.splice(index, 1);
          }
        }
      }
    }
  },
  mounted() {
    if (this.items) {
      this.listItems = this.listItems.concat(this.items);
    }
  },
  computed: {
    hasAll() {
      return (this.listItems.length > 0) && (this.selected.length > 0)
    },
    disable() {
      return (this.selected.length == this.max);
    }
  },
  watch: {
    items: function(value) {
      if (value) {
        this.listItems = this.listItems.concat(value);
      }
    },
    selectedItems: function(value) {
      if (value) {
        this.selected = this.selected.concat(value);
      }
    },
    hasAll(value) {
      if (value) {
        this.selected = []
        this.listItems.map(item => {
          if (this.selectedItems.indexOf(item.id) > -1) {
            this.selected.push(item)
          }
        })
        this.removeSelecteds()
      }
    }
  }
}
</script>

<style lang="scss">
  .categories-editor {
    .btn {
      &.btn-sm {
        padding: 5px 10px;
      }
    }
    .list-values {
      margin: 20px 0;
      padding: 0;
      li {
        overflow: hidden;
        padding: 5px;
        &+li {
          border-top: 1px solid #ccc;
        }
      }
    }
  }
  .two-columns {
    @media (min-width: 968px) {
      overflow: hidden;
      display: flex;
      flex-wrap: wrap;
      .checkbox {
        min-height: 36px;
        flex: 1 0 50%;
        &:first-child {
          margin-top: 0;
        }
      }
    }
  }
</style>
